import { type IKoaBodyOptions } from 'koa-body';
import { type Context, type Middleware } from 'koa';
export interface RouterData {
    class: new (ctx: Context) => any;
    actionName: string;
}
export interface CachedRouter {
    [path: string]: RouterData;
}
export interface AppConfig {
    proxy?: boolean;
    port?: number | string;
    controllerRoot: string;
    defaultAction?: string;
    beforeAction?: string;
    bodyOptions?: IKoaBodyOptions;
    onStart?: () => Promise<void> | void;
    middlewares?: Middleware[];
}
export declare class App {
    private config;
    constructor(option: AppConfig);
    private cachedRouter;
    private detectAllRouter;
    run(): Promise<void>;
}
