import { Db, Collection as MCol, Document, Filter, MatchKeysAndValues, ObjectId, FindOptions, Sort } from 'mongodb';
export declare class Collection {
    name: string;
    db: Db;
    instance: MCol;
    lastInsertedId?: ObjectId;
    lastInsertedIds?: {
        [key: number]: ObjectId;
    };
    constructor(name: string, db: Db);
    remove(filter: Filter<Document>): Promise<boolean>;
    update(filter?: Filter<Document>, data?: MatchKeysAndValues<Document>): Promise<boolean>;
    count(filter?: Filter<Document>, option?: FindOptions<Document>): Promise<number>;
    upsert(filter?: Filter<Document>, data?: MatchKeysAndValues<Document>): Promise<boolean>;
    add(data: Document): Promise<boolean>;
    adds(data: Document[]): Promise<boolean>;
    find(filter?: Filter<Document>, option?: FindOptions<Document>): Promise<import("mongodb").WithId<Document>[]>;
    get(filter?: Filter<Document>, sort?: Sort): Promise<import("mongodb").WithId<Document> | null>;
    gets(filter?: Filter<Document>, sort?: Sort, offset?: number, limit?: number): Promise<import("mongodb").WithId<Document>[]>;
}
