"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = void 0;
const path_1 = __importDefault(require("path"));
class Config {
    constructor(basePath, defaultFile = 'default') {
        this.basePath = basePath;
        this.defaultFile = defaultFile;
        const defaultPath = path_1.default.resolve(this.basePath, this.defaultFile);
        let envPath;
        if (process.env.NODE_ENV) {
            envPath = path_1.default.resolve(this.basePath, process.env.NODE_ENV);
        }
        this.all = require(defaultPath);
        if (envPath) {
            const envConfig = require(envPath);
            this.all = Object.assign(Object.assign({}, this.all), envConfig);
        }
    }
    item(key) {
        return this.all[key];
    }
}
exports.Config = Config;
