"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controller = void 0;
class Controller {
    constructor(context) {
        this.context = context;
    }
    json(data = null, code = 0, message = 'ok') {
        this.context.status = 200;
        this.context.type = 'application/json';
        this.context.body = JSON.stringify({
            data,
            code,
            message,
        });
    }
    get(name, value) {
        var _a;
        if (!name) {
            return this.context.query;
        }
        return (_a = this.context.query[name]) !== null && _a !== void 0 ? _a : value;
    }
    post(name, value) {
        var _a;
        if (!name) {
            return this.context.request.body;
        }
        return (_a = this.context.request.body[name]) !== null && _a !== void 0 ? _a : value;
    }
    param(name, value) {
        if (!name) {
            return Object.assign(Object.assign({}, this.post()), this.get());
        }
        let result = this.get(name, value);
        if (result)
            return result;
        result = this.post(name, value);
        return result !== null && result !== void 0 ? result : value;
    }
    method() {
        return this.context.method.toUpperCase();
    }
}
exports.Controller = Controller;
