"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongoDB = void 0;
const mongodb_1 = require("mongodb");
class MongoDB {
    static create(uri = 'mongodb://127.0.0.1:27017') {
        return __awaiter(this, void 0, void 0, function* () {
            let client = MongoDB.clients[uri];
            if (client && client instanceof mongodb_1.MongoClient) {
                return client;
            }
            client = new mongodb_1.MongoClient(uri, {
                keepAlive: true,
                noDelay: true,
            });
            client.once('serverClosed', () => {
                delete MongoDB.clients[uri];
            });
            yield client.connect();
            MongoDB.clients[uri] = client;
            return client;
        });
    }
    db(name) {
        return this.db(name);
    }
}
exports.MongoDB = MongoDB;
MongoDB.clients = {};
