"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MySQL = void 0;
const Table_1 = require("./Table");
const promise_1 = require("mysql2/promise");
class MySQL {
    constructor(pool, debug = false) {
        this.pool = pool;
        this.debug = debug;
    }
    static getInstance(option) {
        let config = {
            limit: 10,
            host: '127.0.0.1',
            port: 3306,
            user: 'root',
            charset: 'utf8mb4',
            debug: false,
        };
        if (option && typeof option === 'object') {
            config = Object.assign(Object.assign({}, config), option);
        }
        const cacheKey = JSON.stringify(config);
        if (cacheKey in MySQL.instances) {
            return MySQL.instances[cacheKey];
        }
        const pool = (0, promise_1.createPool)({
            host: config.host,
            port: config.port,
            user: config.user,
            password: config.password,
            charset: config.charset,
            database: config.database,
            connectionLimit: config.limit,
            waitForConnections: true,
        });
        const instance = new MySQL(pool, config.debug);
        MySQL.instances[cacheKey] = instance;
        return instance;
    }
    table(name) {
        return new Table_1.Table(name, this);
    }
}
exports.MySQL = MySQL;
MySQL.instances = {};
