import { Pool } from 'mysql2/promise';
import { SQLParser } from './SQLParser';
export interface DB {
    pool: Pool;
    debug: boolean;
}
export declare class Table extends SQLParser {
    #private;
    name: string;
    db: DB;
    lastInsertedId?: number;
    constructor(name: string, db: DB);
    get<T = any>(where?: Record<string, any> | null, order?: Record<string, Uppercase<'ASC' | 'DESC'>> | null, field?: string): Promise<T | null>;
    gets<T = any>(where?: Record<string, any> | null, order?: Record<string, any> | null, offset?: number, limit?: number, field?: string): Promise<Array<T>>;
    add(data: Record<string, any>): Promise<boolean>;
    remove(where?: Record<string, any> | null, order?: Record<string, any> | null, limit?: number): Promise<boolean>;
    count(where?: Record<string, any>): Promise<number>;
    update(data: Record<string, any>, where?: Record<string, any> | null, order?: Record<string, any> | null, limit?: number): Promise<boolean>;
    upsert(data: Record<string, any>, where?: Record<string, any> | null): Promise<boolean>;
}
